package com.sunyard.ssp.modules.monitor.log.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;


@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("SC_AUDIT_LOG_SIGN")
@ApiModel(value="日志签名关联表", description="")
public class AuditLogSign implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId("ID")
    private Long id;

    @ApiModelProperty(value = "日志签名id")
    @TableField("SIGN_ID")
    private Long signId;

    @ApiModelProperty(value = "日志id")
    @TableField("LOG_ID")
    private Long logId;

}
